package com.andy.kads.controller;

import com.andy.kads.utils.UdpUtils;
import com.google.common.cache.CacheBuilder;
import com.google.common.cache.CacheLoader;
import com.google.common.cache.LoadingCache;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.TimeUnit;

/**
 * Created by IntelliJ IDEA.
 * User: andy.qu
 * Date: 2022/5/30
 */
@RestController
public class SendController {

    //maximumSize 设置缓存大小
    static LoadingCache<String, String> cache =
            CacheBuilder.newBuilder().maximumSize(100).
                    expireAfterWrite(1000 * 3, TimeUnit.MILLISECONDS).build(new CacheLoader<String, String>() {
                @Override
                public String load(String s) throws Exception {
                    return "";
                }
            });

    private Map<String, String> mMap = new HashMap<String, String>() {{
        put("00", "02 4D 30 31 30 30 30 30 30 30 30 30 30 30 30 31 03");
        put("01", "02 54 30 31 30 30 31 30 30 30 30 30 30 30 30 32 20 03");
        put("02", "02 54 30 31 30 30 32 30 30 30 30 30 30 30 30 33 20 03");
        put("03", "02 54 30 31 30 30 33 30 30 30 30 30 30 30 30 34 20 03");
        put("04", "02 54 30 31 30 30 34 30 30 30 30 30 30 30 30 35 20 03");
        put("05", "02 54 30 31 30 30 35 30 30 30 30 30 30 30 30 36 20 03");
        put("06", "02 54 30 31 30 30 36 30 30 30 30 30 30 30 30 37 20 03");
        put("07", "02 54 30 31 30 30 37 30 30 30 30 30 30 30 30 38 20 03");
        put("08", "02 54 30 31 30 30 38 30 30 30 30 30 30 30 30 39 20 03");
        put("09", "02 54 30 31 30 30 39 30 30 30 30 30 30 30 31 30 20 03");
        put("10", "02 54 30 31 30 31 30 30 30 30 30 30 30 30 30 32 20 03");
        put("11", "02 54 30 31 30 31 31 30 30 30 30 30 30 30 30 33 20 03");
        put("12", "02 54 30 31 30 31 32 30 30 30 30 30 30 30 30 34 20 03");
        put("13", "02 54 30 31 30 31 33 30 30 30 30 30 30 30 30 35 20 03");
        put("14", "02 54 30 31 30 31 34 30 30 30 30 30 30 30 30 36 20 03");
        put("15", "02 54 30 31 30 31 35 30 30 30 30 30 30 30 30 37 20 03");
        put("16", "02 54 30 31 30 31 36 30 30 30 30 30 30 30 30 38 20 03");
    }};

    @GetMapping()
    public Object send(@RequestParam(name = "type") String type) {
        try {
            /*if (type.equals("00")) {
                cache.put("00", "123");
            } else {
                if (!StringUtils.isEmpty(cache.get("00"))) {
                    return "0E";
                }
            }*/

            String order = mMap.get(type);
            if (!StringUtils.isEmpty(order)) {
                UdpUtils.sendMsg(order);
            }

            return "06";
        } catch (Exception e) {
            e.printStackTrace();
            return "0E";
        }

    }
}